//----------------------------------------------------------------------------
// advsprd.hpp - bcbdcc32 generated hdr (DO NOT EDIT) rev: 0
// From: advsprd.pas
//----------------------------------------------------------------------------
#ifndef advsprdHPP
#define advsprdHPP
//----------------------------------------------------------------------------
#include <Controls.hpp>
#include <Messages.hpp>
#include <Grids.hpp>
#include <Windows.hpp>
#include <SysUtils.hpp>
#include <Classes.hpp>
#include <Parser.hpp>
#include <AdvGrid.hpp>
#include <System.hpp>
namespace Advsprd
{
//-- type declarations -------------------------------------------------------
typedef void __fastcall (__closure *TFormulaErrorEvent)(System::TObject* Sender, int aCol, int aRow, 
	 System::AnsiString S);

typedef void __fastcall (__closure *TCellFormatEvent)(System::TObject* Sender, long ACol, long Arow, 
	 System::AnsiString &format, bool &datetype);

struct TCellRef;
typedef TCellRef *PCellRef;

struct TCellRef
{
	Grids::TGridCoord src;
	Grids::TGridCoord dst;
	bool dirty;
} ;

class __declspec(delphiclass) TCellRefList;
class __declspec(pascalimplementation) TCellRefList : public Classes::TList
{
	typedef Classes::TList inherited;
	
private:
	TCellRef __fastcall GetCellRef(int Index);
	void __fastcall ShowCellRefs(void);
	
public:
	__fastcall TCellRefList(void);
	__fastcall virtual ~TCellRefList(void);
	__property TCellRef CellRefs[int index] = {read=GetCellRef/*, default*/};
	HIDESBASE void __fastcall Add(const TCellRef &Value);
	HIDESBASE void __fastcall Delete(int Index);
	void __fastcall DeleteRef(const Grids::TGridCoord &gc);
	void __fastcall DeleteAll(void);
	void __fastcall ClearAll(void);
};

class __declspec(delphiclass) TAdvSpreadGrid;
class __declspec(pascalimplementation) TAdvSpreadGrid : public Advgrid::TAdvStringGrid
{
	typedef Advgrid::TAdvStringGrid inherited;
	
private:
	Parser::TGridFormula* FGridFormula;
	bool FCalcBusy;
	bool FShowFormula;
	bool FAutoRecalc;
	System::AnsiString FCellFormat;
	TCellFormatEvent FOnCellFormat;
	TFormulaErrorEvent FOnFormulaError;
	TCellRefList* FCellRefList;
	System::AnsiString FErrorText;
	HIDESBASE MESSAGE void __fastcall WMLButtonDown(Messages::TWMMouse &Msg);
	void __fastcall SetShowFormula(const bool Value);
	void __fastcall SetCellFormat(const System::AnsiString Value);
	void __fastcall CalcFormula(int acol, int arow);
	void __fastcall DelCellRef(int acol, int arow);
	void __fastcall AddCellRef(int acol, int arow,  System::AnsiString s);
	void __fastcall CalcCellRef(int acol, int arow);
	void __fastcall UpdCellRef(void);
	Parser::TIsCustomFunction __fastcall GetIsCustomFunction(void);
	void __fastcall SetIsCustomFunction(Parser::TIsCustomFunction value);
	Parser::TCalcCustomFunction __fastcall GetCalcCustomFunction(void);
	void __fastcall SetCalcCustomFunction(Parser::TCalcCustomFunction value);
	double __fastcall GetCellValue(int c, int r);
	
protected:
	virtual System::AnsiString __fastcall CalcCell(int ACol, int ARow);
	virtual void __fastcall UpdateCell(int ACol, int ARow);
	virtual void __fastcall PasteNotify(const tagPOINT &orig, const Grids::TGridRect &gr);
	virtual void __fastcall SetEditText(long ACol, long ARow, const System::AnsiString Value);
	System::AnsiString __fastcall ModifyRange( System::AnsiString s, int ptx, int pty, int ofsx, int ofsy
		, int rngx, int rngy);
	System::AnsiString __fastcall ModifyName( System::AnsiString s, int ptx, int pty, int ofsx, int ofsy
		);
	System::AnsiString __fastcall ModifyFormula( System::AnsiString s, int ptx, int pty, int ofsx, int 
		ofsy, int rngx, int rngy);
	
public:
	__fastcall virtual TAdvSpreadGrid(Classes::TComponent* aOwner);
	__fastcall virtual ~TAdvSpreadGrid(void);
	virtual int __fastcall GetVersionNr(void);
	virtual System::AnsiString __fastcall GetVersionString(void);
	virtual void __fastcall ClearRect(int aCol1, int aRow1, int aCol2, int aRow2);
	void __fastcall AutoSpreadHeaders(void);
	void __fastcall RecalcCell(int acol, int arow);
	void __fastcall Recalc(void);
	System::AnsiString __fastcall CellToName(int col, int row);
	Grids::TGridCoord __fastcall NameToCell( System::AnsiString s);
	System::AnsiString __fastcall RangeToName(const Grids::TGridRect &gr);
	Grids::TGridRect __fastcall NameToRange( System::AnsiString s);
	virtual void __fastcall RemoveRows(long RowIndex, long RCount);
	virtual void __fastcall InsertRows(long RowIndex, long RCount);
	virtual void __fastcall RemoveCols(long ColIndex, long CCount);
	virtual void __fastcall InsertCols(long ColIndex, long CCount);
	__property System::AnsiString ErrorText = {read=FErrorText, write=FErrorText, nodefault};
	__property double CellValue[int c][int r] = {read=GetCellValue};
	
__published:
	__property bool ShowFormula = {read=FShowFormula, write=SetShowFormula, nodefault};
	__property bool AutoRecalc = {read=FAutoRecalc, write=FAutoRecalc, nodefault};
	__property System::AnsiString CellFormat = {read=FCellFormat, write=SetCellFormat, nodefault};
	__property TCellFormatEvent OnCellFormat = {read=FOnCellFormat, write=FOnCellFormat};
	__property TFormulaErrorEvent OnFormulaError = {read=FOnFormulaError, write=FOnFormulaError};
	__property Parser::TIsCustomFunction OnIsCustomFunction = {read=GetIsCustomFunction, write=SetIsCustomFunction
		};
	__property Parser::TCalcCustomFunction OnCalcCustomFunction = {read=GetCalcCustomFunction, write=SetCalcCustomFunction
		};
public:
	/* TWinControl.CreateParented */ __fastcall TAdvSpreadGrid(HWND ParentWindow) : Advgrid::TAdvStringGrid(
		ParentWindow) { }
	
};

//-- var, const, procedure ---------------------------------------------------
#define err_recurs "Circular cell formula"
#define err_parser "Formula parser error"
#define err_recursrange "Circular range formula"
#define err_invalrange "Invalid range"
#define err_empty "Empty formula"

}	/* namespace Advsprd */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Advsprd;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// advsprd
